type 'a partition = Partition of ('a -> int) * (int vect) * int * (int vect) ;;

(* on fournit la liste d'objets, et une fonction qui permet de les numroter de 0  n-1 *)
(* on retourne la partition constitue des singletons *)
let liste_en_partition l numrote =
	let taille = list_length l
	in
	let poids = make_vect taille 0 and pre = make_vect taille 0
	in
	for i = 0 to taille-1 do pre.(i) <- i done ;
	Partition(numrote,poids,taille,pre) ;;
	
(* fusionne les deux parties numrotes i et j en une seule *)
let fusionne_paquets p i j =
	match p with Partition(_,poids,_,pre) -> if i <> j then
	if poids.(i) = poids.(j) then begin poids.(i) <- poids.(i) + 1 ; pre.(j) <- i end
	else if poids.(i) > poids.(j) then pre.(j) <- i else pre.(i) <- j ;;
	
(* renvoie le numro de la partie qui contient l'objet a *)
let trouve_paquet p a =
	match p with Partition(numrote,poids,_,pre) ->
	let x = numrote a
	in
	let rec monte_au_pre i = 	if pre.(i) = i then i else monte_au_pre pre.(i)
	in
	let r = monte_au_pre x
	in
	let rec dirige_au_pre i =
				if i = r	then ()
							else ( dirige_au_pre pre.(i) ; pre.(i) <- r )
	in dirige_au_pre x ; r ;;
	
(* renvoie le nombre de parties qui constituent la partition *)
let nbre_de_paquets p =
	match p with Partition(_,_,n,pre) ->
	let nb = ref 0 in for i = 0 to n-1 do if i = pre.(i) then nb := 1 + !nb done ; !nb ;;
	
(* dit si deux objets sont dans la mme partie *)
let mme_paquet p a b = (trouve_paquet p a) = (trouve_paquet p b) ;;
	
(* regroupe les paquets qui contiennent deux lments donns en un seul paquet *)
let regroupe_2_en_paquet p a b = fusionne_paquets p (trouve_paquet p a) (trouve_paquet p b) ;;

(* regroupe les paquets qui contiennent n lments donns en un seul paquet *)
let rec regroupe_n_en_paquet p = function
	  [] -> ()
	| a :: [] -> ()
	| a :: b :: q -> regroupe_2_en_paquet p a b ; regroupe_n_en_paquet p (a :: q) ;;
